﻿Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports Sorting.Sorting.Models
Namespace Sorting.Models
#Region "Models"
    Public Class Student
        ''' <summary>
        ''' Gets or sets the UniversiryCode
        ''' </summary>
        ''' 
        <Range(0, Integer.MaxValue, ErrorMessage:="UniversityCode must be greater than 0.")> _
        Public Property UniversityCode() As Long
            Get
                Return m_UniversityCode
            End Get
            Set(ByVal value As Long)
                m_UniversityCode = value
            End Set
        End Property
        Private m_UniversityCode As Long
        ''' <summary>
        ''' Gets or sets the FirstName
        ''' </summary>
        ''' 
        <StringLength(5, ErrorMessage:="CustomerID must be 5 characters.")> _
        Public Property FirstName() As String
            Get
                Return m_FirstName
            End Get
            Set(ByVal value As String)
                m_FirstName = value
            End Set
        End Property
        Private m_FirstName As String
        ''' <summary>
        ''' Gets or sets the LastName
        ''' </summary>
        ''' 
        <StringLength(5, ErrorMessage:="CustomerID must be 5 characters.")> _
        Public Property LastName() As String
            Get
                Return m_LastName
            End Get
            Set(ByVal value As String)
                m_LastName = value
            End Set
        End Property
        Private m_LastName As String
        ''' <summary>
        ''' Gets or sets the duration in days of the course
        ''' </summary>                
        ''' 
        <RegularExpression("^(0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])[- /.](19|20)\d\d$", ErrorMessage:="Date is required")> _
        Public Property BirthDate() As System.Nullable(Of Date)
            Get
                Return m_BirthDate
            End Get
            Set(ByVal value As System.Nullable(Of Date))
                m_BirthDate = value
            End Set
        End Property
        Private m_BirthDate As System.Nullable(Of Date)
        Property Title As Object
        Property Duration As Object
        Property CourseFees As Object
        Property CGPA As Object
    End Class
    Public Class StudentDataContext
#Region "Properties"
        ''' <summary>
        ''' Gets  the courses in a IQueryable format
        ''' </summary>
        Public ReadOnly Property Student() As List(Of Student)
            Get
                Dim studen As New List(Of Student)()
                Dim stu As New Student()
                Dim code As Integer = 10000
                For i As Long = 1 To 199
                    Dim s As Student() = New Student(6) {}
                    s(0) = New Student() With { _
                     .UniversityCode = code + 1, _
                     .FirstName = "AAA", _
                     .LastName = "HHH", _
                     .BirthDate = "1/4/2011 12:00:00 AM" _
                    }
                    s(1) = New Student() With { _
                     .UniversityCode = code + 2, _
                     .FirstName = "BBB", _
                     .LastName = "III", _
                     .BirthDate = "1/8/2011 12:00:00 AM" _
                    }
                    s(2) = New Student() With { _
                         .UniversityCode = code + 3, _
                     .FirstName = "CCC", _
                     .LastName = "JJJ", _
                     .BirthDate = "1/7/2011 12:00:00 AM" _
                    }
                    s(3) = New Student() With { _
                         .UniversityCode = code + 4, _
                     .FirstName = "DDD", _
                     .LastName = "KKK", _
                     .BirthDate = "4/5/2011 12:00:00 AM" _
                    }
                    s(4) = New Student() With { _
                         .UniversityCode = code + 5, _
                     .FirstName = "EEE", _
                     .LastName = "LLL", _
                     .BirthDate = "7/1/2011 12:00:00 AM" _
                    }
                    s(5) = New Student() With { _
                         .UniversityCode = code + 6, _
                     .FirstName = "FFF", _
                     .LastName = "MMM", _
                     .BirthDate = "6/9/2011 12:00:00 AM" _
                    }
                    s(6) = New Student() With { _
                         .UniversityCode = code + 7, _
                     .FirstName = "GGG", _
                     .LastName = "NNN", _
                     .BirthDate = "2/1/2011 12:00:00 AM" _
                    }
                    For Each studnt As Student In s
                        studen.Add(studnt)
                    Next
                    code += 10
                Next
                Return studen
            End Get
        End Property
#End Region
    End Class
     Public Class OrderRepository
        Public Shared Function GetAllRecords() As IList(Of Student)
            Dim orders As IList(Of Student) = CType(HttpContext.Current.Session("Student Details"), IList(Of Student))
            If orders Is Nothing Then
                orders = (
                From ord In New StudentDataContext().Student.Take(100)
                Select New Student With {.UniversityCode = ord.UniversityCode, .Title = ord.Title, .FirstName = ord.FirstName, .LastName = ord.LastName, .BirthDate = ord.BirthDate, .Duration = ord.Duration, .CourseFees = ord.CourseFees, .CGPA = ord.CGPA}).ToList()
                HttpContext.Current.Session("Student Details") = orders
            End If
            Return orders
        End Function
        Public Shared Sub Add(ByVal order As Student)
            GetAllRecords().Insert(0, order)
        End Sub
        Public Shared Sub Add(ByVal orders As IEnumerable(Of Student))
            For Each order In orders
                GetAllRecords().Insert(0, order)
            Next order
        End Sub
        Public Shared Function [Select](ByVal UniversityCode? As Long) As Student
            Dim result As Student = GetAllRecords().Where(Function(o) o.UniversityCode.Equals(UniversityCode)).FirstOrDefault()
            Return result
        End Function
        Public Shared Sub Delete(ByVal UniversityCode As Long)
            Dim result As Student = GetAllRecords().Where(Function(o) o.UniversityCode = UniversityCode).FirstOrDefault()
            GetAllRecords().Remove(result)
        End Sub
        Public Shared Sub Delete(ByVal orders As IEnumerable(Of Student))
            For Each res In orders
                Dim result As Student = GetAllRecords().Where(Function(o) o.UniversityCode = res.UniversityCode).FirstOrDefault()
                GetAllRecords().Remove(result)
            Next res
        End Sub
        Public Shared Sub Update(ByVal order As Student)
            ' For Each ord In order
            Dim result As Student = GetAllRecords().Where(Function(o) o.UniversityCode = order.UniversityCode).FirstOrDefault()
            If result IsNot Nothing Then
                result.UniversityCode = order.UniversityCode
                result.Title = order.Title
                result.FirstName = order.FirstName
                result.LastName = order.LastName
                result.Duration = order.Duration
                result.CourseFees = order.CourseFees
                result.CGPA = order.CGPA
            End If
            'Next order
        End Sub
        Public Shared Sub Update(ByVal orders As IEnumerable(Of Student))
            For Each order In orders
                Dim result As Student = GetAllRecords().Where(Function(o) o.UniversityCode = order.UniversityCode).FirstOrDefault()
                If result IsNot Nothing Then
                    result.UniversityCode = order.UniversityCode
                    result.Title = order.Title
                    result.Duration = order.Duration
                    result.FirstName = order.FirstName
                    result.LastName = order.LastName
                    result.CourseFees = order.CourseFees
                    result.CGPA = order.CGPA
                End If
            Next order
        End Sub
    End Class
#End Region
End Namespace
